;; edit music.software.html and make install.bat

(load "nyinit.lsp")

(setf *afs* "q:\\web")

(defun edit-music-software-html ()
  (let (inf outf input i prefix postfix postfix1 postfix2)
    (setf inf (open "music.software.html"))
    (if (null inf) (error "could not open music.software.html"))
    (setf outf (open "new.html" :direction :output))
    (if (null outf) (error "could not open new.html for output"))
    (format t "Major version number (e.g. 2): ")
    (setf *maj* (read))
    (format t "Minor version number (e.g. 27): ")
    (setf *min* (read))
    
    ;; find version in heading
    (print "find Executables")
    (setf input (read-line inf))
    (while (not (setf i (string-search "Executables (v" input)))
      (format outf "~A~%" input)
      (setf input (read-line inf)))
    (setf prefix (subseq input 0 (+ i 14)))
    (setf postfix (subseq input (+ i 14)))
    (setf i (string-search ")" postfix))
    (setf postfix (subseq postfix i))
    (format outf "~A~A.~A~A~%" prefix *maj* *min* postfix)
    
    ;; find nyquist/setupnyqrun
    (print "find nyquist/setupnyqrun")
    (setf input (read-line inf))
    (while (not (setf i (string-search "nyquist/setupnyqrun" input)))
      (format outf "~A~%" input)
      (setf input (read-line inf))
      ;(display "finding nyquist/setupnyqrun" input)
      )
    (setf prefix (subseq input 0 (+ i 19)))
    (setf postfix (subseq input (+ i 19)))
    (setf i (string-search "\">" postfix))
    (setf postfix (subseq postfix i))
    (format outf "~A~A~A.exe~A~%" prefix *maj* *min* postfix)

    ;; find nyquist/setupnyqwinrun
    (print "find nyquist/setupnyqwinrun")
    (setf input (read-line inf))
    (while (not (setf i (string-search "nyquist/setupnyqwinrun" input)))
      (format outf "~A~%" input)
      (setf input (read-line inf)))
    (setf prefix (subseq input 0 (+ i 22)))
    (setf postfix (subseq input (+ i 22)))
    (setf i (string-search "\">" postfix))
    (setf postfix (subseq postfix i))
    (format outf "~A~A~A.exe~A~%" prefix *maj* *min* postfix)

    ;; find nyquist/setupnyqiderun
    (print "find nyquist/setupnyqiderun")
    (setf input (read-line inf))
    (while (not (setf i (string-search "nyquist/setupnyqiderun" input)))
      (format outf "~A~%" input)
      (setf input (read-line inf)))
    (setf prefix (subseq input 0 (+ i 22)))
    (setf postfix (subseq input (+ i 22)))
    (setf i (string-search "\">" postfix))
    (setf postfix (subseq postfix i))
    (format outf "~A~A~A.exe~A~%" prefix *maj* *min* postfix)
    
    ;; find nyquist/nyqsrc
    (print "find nyquist/nyqsrc")
    (setf input (read-line inf))
    (while (not (setf i (string-search "nyquist/nyqsrc" input)))
      (format outf "~A~%" input)
      (setf input (read-line inf)))
    (setf prefix (subseq input 0 (+ i 14)))
    (setf postfix (subseq input (+ i 14)))
    (setf i (string-search ".zip" postfix))
    (setf postfix (subseq postfix i))
    (setf i (string-search "(v" postfix))
    (setf postfix1 (subseq postfix 0 (+ i 2)))
    (setf postfix2 (subseq postfix (+ i 2)))
    (setf i (string-search ")" postfix2))
    (setf postfix2 (subseq postfix2 i))
    (format outf "~A~A~A~A~A.~A~A~%" prefix *maj* *min*
            postfix1 *maj* *min* postfix2)

    (setf input (read-line inf))
    (while input
      (format outf "~A~%" input)
      (setf input (read-line inf)))
      
    (close inf)
    (close outf)
   ))

; "

(defun make-install-bat ()
  (let (outf)
    (setf outf (open "cmuinstall2.bat" :direction :output))
    (format outf "copy ..\\..\\setup\\setupnyqrun.exe ~A\\nyquist\\setupnyqrun~A~A.exe~%"
            *afs* *maj* *min*)
    (format outf "copy ..\\..\\setup\\setupnyqwinrun.exe ~A\\nyquist\\setupnyqwinrun~A~A.exe~%"
            *afs* *maj* *min*)
    (format outf "copy ..\\..\\setup\\setupnyqiderun.exe ~A\\nyquist\\setupnyqiderun~A~A.exe~%"
            *afs* *maj* *min*)
    (format outf "copy new.html ~A\\music.software.html~%" *afs*)
    (format outf "call cleanup.bat~%")
    (format outf "echo \"In d:\\rbd, make nyquist.zip from nyquist now...then type return to the pause...\"~%")
    (format outf "pause~%")
    (format outf "move ..\\..\\..\\nyquist.zip ..\\..\\..\\nyquist~A~A.zip~%" *maj* *min*)
    (format outf "copy ..\\..\\..\\nyquist~A~A.zip ~A\\nyquist\\nyqsrc~A~A.zip~%"
            *maj* *min* *afs* *maj* *min*)
    (format outf "call restore.bat~%")
    (close outf)))

(edit-music-software-html)
(make-install-bat)


(exit)

